do
	local oldCreateMouseover = CreateMouseover
	function CreateMouseover(control, data)
		if data.Tab == 'C' or data.Tab == 'E' then
			data.Tab = 'T4'
		end
		oldCreateMouseover(control, data)
	end
	
	function UpdateIdleBuilders()
	    local idleEngineers = {}
	    
	    idleEngineers = GetIdleEngineers()
	    
	    local engineers = {}
	    local EngLabels = {1,2,3,4,'E','C'}
	    if idleEngineers then
			local allSCUs = EntityCategoryFilterDown(categories.SUBCOMMANDER, idleEngineers)
			if allSCUs then
				for i, unit in allSCUs do
					if unit.SCUType then
						if unit.SCUType == 'Combat' then
							if not engineers[6] then
								engineers[6] = {}
							end
							table.insert(engineers[6], unit)
						elseif unit.SCUType == 'Engineer' then
							if not engineers[5] then
								engineers[5] = {}
							end
		 					table.insert(engineers[5], unit)
						end
					else
						if not engineers[4] then
							engineers[4] = {}
						end
						table.insert(engineers[4], unit)
					end
				end
			end
	        engineers[3] = EntityCategoryFilterDown(categories.TECH3 - categories.SUBCOMMANDER, idleEngineers)
	        engineers[2] = EntityCategoryFilterDown(categories.TECH2, idleEngineers)
	        engineers[1] = EntityCategoryFilterDown(categories.TECH1, idleEngineers)
	    end
	    for i, v in avatars do
	        if v.Type == 'Engineer' then
	            local found = false
	            for h, x in engineers do
	                if h == v.ID and table.getsize(x) > 0 then
	                    found = true
	                    break
	                end
	            end
	            if not found then
	                table.insert(dirtyTable, i)
	            end
	        end
	    end
	    for i, v in engineers do
	        if table.getsize(v) > 0 then
	            local found = false
	            local tempTable = {}
				if i == 5 or i == 6 then
					tempTable = {
						Type = 'Engineer',
						ID = i,
						Tab = EngLabels[i],
						Label = LOCF("<LOC avatar_0000>%d", table.getsize(v)),
						Units = {},
					}
				else
					tempTable = {
						Type = 'Engineer',
						ID = i,
						Tab = LOCF("<LOC _T_digit>T%d", EngLabels[i]),
						Label = LOCF("<LOC avatar_0000>%d", table.getsize(v)),
						Units = {},
					}
				end
	            for index, unit in v do
	                table.insert(tempTable.Units, unit)
	            end
	            for h, x in avatars do
	                if x.Type == 'Engineer' and x.ID == i then
	                    found = true
	                    if x.icon.Update then
	                        x.icon.Update(tempTable)
	                    end
	                    break
	                end
	            end
	            if not found then
	                table.insert(avatars, tempTable)
	            end
	        end
	    end
	end
	
	local oldUpdateAvatarIcons = UpdateAvatarIcons
	function UpdateAvatarIcons()
		oldUpdateAvatarIcons()
		local buttons = import('/mods/scu manager/scumanager.lua').buttonGroup
		local showing = false
		for i, v in avatars do
			if v.Type == 'Engineer' then
				if v.icon then
					if v.ID == 4 then
						buttons:Show()
						buttons.Right:Set(v.icon.Left)
						buttons.Top:Set(v.icon.Top)
						showing = true
					end
				end
			end
		end
		if not showing then
			buttons:Hide()
		end
	end
end
